import { type Fiber, type DarkElement, type Component } from '@dark-engine/core';
import type { TagNativeElement } from '../native-element';
declare const $$portal: unique symbol;
declare function createPortal(
  slot: DarkElement,
  container: TagNativeElement,
): Component<
  PortalProps &
    import('@dark-engine/core').KeyProps &
    import('@dark-engine/core').RefProps<unknown> &
    import('@dark-engine/core').FlagProps,
  unknown
>;
type PortalProps = {
  [$$portal]: TagNativeElement;
  slot: DarkElement;
};
declare const detectIsPortal: (instance: unknown) => instance is Component<any, any>;
declare const getPortalContainer: (factory: unknown) => TagNativeElement | null;
declare function unmountPortal(fiber: Fiber<TagNativeElement>): void;
export { createPortal, detectIsPortal, getPortalContainer, unmountPortal };
